import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.nio.charset.*;
import java.nio.file.*;
import java.util.*;
import java.util.prefs.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;

import javax.swing.text.Highlighter.HighlightPainter;

//-------------------------------------
public class EdtVid extends JFrame {

static EdtVid      mf;

JButton            sbar;
JList<JLabel>      lbox;
JScrollPane        splb, spta;
JTextArea          txta;

ArrayList<String>  fils;
File[]             files;
Font               taf, uif;
Image              iimg;
int                maxx, maxy, winx, winy;
int                tafs, uifs, wxp, wyp;
int                dbgn, dend, sidx;
//LogMsgs            lm;
String             cmd, ofd, stxt, tafn, uifn, wdir;

Vector<JLabel>     vjl;

static final int  UIFSIZ    = 32;
static final int  TAFSIZ    = 20;
static final int  WXP       = 50;
static final int  WYP       = 50;
static final String UIFNLIT = "UIFN";
static final String UIFSLIT = "UIFS";
static final String TAFNLIT = "TAFN";
static final String TAFSLIT = "TAFS";
static final String WXPLIT  = "WXP";
static final String WYPLIT  = "WYP";
static final String APPNAM  = "EdtVid";

static final String FILS    = "files.txt";

//-------------------------------------
class ADirectory implements ActionListener {
public void actionPerformed(ActionEvent qae) {
File              fil;
int               fsts;
JFileChooser      jfc;
  jfc = new JFileChooser(ofd);
  jfc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  jfc.setDialogTitle("Output Directory");
  try {
    jfc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
  } catch (Exception x) { System.err.format("Exception: %s%n", x); }
  fsts = jfc.showOpenDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    fil = jfc.getSelectedFile();
    ofd = fil.getPath()+File.separator;
    sbar.setText(ofd);
  }
  ListFiles();
}}

//-------------------------------------
class AMinimize implements ActionListener {
public void actionPerformed(ActionEvent qae) {
  mf.setState(Frame.ICONIFIED);
}}

//-------------------------------------
class AQuit implements ActionListener {
public void actionPerformed(ActionEvent qae) {
  System.exit(0);
}}

//-------------------------------------
class AVideo implements ActionListener {
public void actionPerformed(ActionEvent qae) {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("Convert");
  mi.setMnemonic('C');
  mi.addActionListener(new AVideoConvert());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Crop");
  mi.setMnemonic('R');
  mi.addActionListener(new AVideoCrop());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("ExtractClip");
  mi.setMnemonic('E');
  mi.addActionListener(new AVideoExtractClip());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Join");
  mi.setMnemonic('J');
  mi.addActionListener(new AVideoJoin());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("JoinAll");
  mi.setMnemonic('A');
  mi.addActionListener(new AVideoJoinAll());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Split");
  mi.setMnemonic('S');
  mi.addActionListener(new AVideoSplit());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}}

//-------------------------------------
class AVideoConvert implements ActionListener {
public void actionPerformed(ActionEvent qae) {
File         fil;
int          fsts;
JFileChooser jfc;
String       ifd, ifn, ofn;
  jfc = new JFileChooser(ofd);
  jfc.setDialogTitle("Input File to Convert");
  jfc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  fsts = jfc.showOpenDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    fil = jfc.getSelectedFile();
    ifd = jfc.getCurrentDirectory()+File.separator;
    ifn = fil.getName();
    jfc = new JFileChooser(ifd);
    jfc.setDialogTitle("Output File of Convert");
    jfc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
    jfc.setFileFilter(new Mp4Filter());
    fsts = jfc.showSaveDialog(mf);
    if (fsts == JFileChooser.APPROVE_OPTION) {
      fil = jfc.getSelectedFile();
      ofd = jfc.getCurrentDirectory()+File.separator;
      ofn = fil.getName();
      cmd = String.format("ffmpeg -y -i %s%s %s%s", ifd, ifn, ofd, ofn);
      RunCmdString();
    }
  }
  ListFiles();
}}

//-------------------------------------
class AVideoCrop implements ActionListener {
public void actionPerformed(ActionEvent qae) {
File         fil;
int          fsts;
JFileChooser jfc;
String       ifd,ifn, ofn, pcrp;
  jfc = new JFileChooser(ofd);
  jfc.setDialogTitle("Input File to Crop");
  jfc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  jfc.setFileFilter(new Mp4Filter());
  fsts = jfc.showOpenDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    fil = jfc.getSelectedFile();
    ifd = jfc.getCurrentDirectory()+File.separator;
    ifn = fil.getName();
    jfc = new JFileChooser(ifd);
    jfc.setDialogTitle("Output File for crop");
    jfc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
    jfc.setFileFilter(new Mp4Filter());
    fsts = jfc.showSaveDialog(mf);
    if (fsts == JFileChooser.APPROVE_OPTION) {
      fil = jfc.getSelectedFile();
      ofd = jfc.getCurrentDirectory()+File.separator;
      ofn = fil.getName();
      pcrp = Util.GetStringValue("Parameters for Crop", "ih:ih", mf);
      cmd = String.format("ffmpeg -y -i %s%s -force_key_frames expr:gte(t,n_forced*1) -vf crop=%s -q:v 0 -c:a copy %s%s", ifd, ifn, pcrp, ofd, ofn);
      RunCmdString();
    }
  }
  ListFiles();
}}

//-------------------------------------
class AVideoExtractClip implements ActionListener {
public void actionPerformed(ActionEvent qae) {
File         fil;
int          dur, fsts, st;
JFileChooser jfc;
String       ifd, ifn, ofn;
  jfc = new JFileChooser(ofd);
  jfc.setDialogTitle("Input File for Extract");
  jfc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  jfc.setFileFilter(new Mp4Filter());
  fsts = jfc.showOpenDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    fil = jfc.getSelectedFile();
    ifd = jfc.getCurrentDirectory()+File.separator;
    ifn = fil.getName();
    jfc = new JFileChooser(ifd);
    jfc.setDialogTitle("Output File for Extract");
    jfc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
    jfc.setFileFilter(new Mp4Filter());
    fsts = jfc.showSaveDialog(mf);
    if (fsts == JFileChooser.APPROVE_OPTION) {
      fil = jfc.getSelectedFile();
      ofd = jfc.getCurrentDirectory()+File.separator;
      ofn = fil.getName();
      st = Util.GetIntValue("Start Time in Seconds", "0", mf);
      if (st==-1) return;
      dur = Util.GetIntValue("Duration", "10", mf);
      if (dur==-1) return;
      cmd = String.format("ffmpeg -y -ss %d -t %d -i %s%s -c copy %s%s", st, dur, ifd, ifn, ofd, ofn);
      RunCmdString();
    }
  }
  ListFiles();
}}

//-------------------------------------
class AVideoJoin implements ActionListener {
public void actionPerformed(ActionEvent qae) {
File         fil;
File[]       sfa;
int          fsts, sd;
JFileChooser jfc;
String       ofn;
  jfc = new JFileChooser(ofd);
  jfc.setDialogTitle("Output of Join");
  jfc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  jfc.setFileFilter(new Mp4Filter());
  fsts = jfc.showSaveDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    fil = jfc.getSelectedFile();
    ofd = jfc.getCurrentDirectory()+File.separator;
    ofn = fil.getName();
    jfc = new JFileChooser(ofd);
    jfc.setDialogTitle("Files to Join");
    jfc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
    jfc.setMultiSelectionEnabled(true);
    jfc.setFileFilter(new Mp4Filter());
    fsts = jfc.showOpenDialog(mf);
    if (fsts == JFileChooser.APPROVE_OPTION) {
      sfa = jfc.getSelectedFiles();
      CreateFileList(sfa);
      cmd = String.format("ffmpeg -y -f concat -safe 0 -i %sfiles.txt -c copy %s%s", ofd, ofd, ofn);
      RunCmdString();
    }
  }
  ListFiles();
}}

//-------------------------------------
class AVideoJoinAll implements ActionListener {
public void actionPerformed(ActionEvent qae) {
File         fil;
File[]       sfa;
int          fsts, sd;
JFileChooser jfc;
String       ofn;
  jfc = new JFileChooser(ofd);
  jfc.setDialogTitle("Output of Join");
  jfc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  jfc.setFileFilter(new Mp4Filter());
  fsts = jfc.showSaveDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    fil = jfc.getSelectedFile();
    ofd = jfc.getCurrentDirectory()+File.separator;
    ofn = fil.getName();
    CreateFileList();
    cmd = String.format("ffmpeg -y -f concat -safe 0 -i %sfiles.txt -c copy %s%s", ofd, ofd, ofn);
    RunCmdString();
  }
  ListFiles();
}}

//-------------------------------------
class AVideoSplit implements ActionListener {
public void actionPerformed(ActionEvent qae) {
File         fil;
int          fsts, sd;
JFileChooser jfc;
String       ifd, ifn, nfs;
  jfc = new JFileChooser(ofd);
  jfc.setDialogTitle("File to Split");
  jfc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  jfc.setFileFilter(new Mp4Filter());
  fsts = jfc.showOpenDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    fil = jfc.getSelectedFile();
    ifd = jfc.getCurrentDirectory()+File.separator;
    if (ofd.length()<1) ofd = ifd;
    ifn = fil.getName();
    sd = Util.GetIntValue("Segment Duration", "10", mf);
    if (sd==-1) return;
    nfs = "%05d.mp4";
  cmd = String.format("ffmpeg -y -i %s%s -f segment -segment_time %d -c:v copy -c:a copy -reset_timestamps 1 -map 0 %szz%s", ifd, ifn, sd, ofd, nfs); 
    RunCmdString();
  }
  ListFiles();
}}

//-------------------------------------
class CBButton implements ActionListener {
public void actionPerformed(ActionEvent cbae) {
  PopupMain();
}}

//-------------------------------------
class CBKey extends KeyAdapter {
public void keyPressed(KeyEvent ke) {
int   kc;
  kc = ke.getKeyCode();
  if (kc == KeyEvent.VK_F1) PopupMain();
}}

//-------------------------------------
class CBResize extends ComponentAdapter {
public void componentResized(ComponentEvent ce) {
Dimension dim;
Insets    is;
  winx = getWidth();
  winy = getHeight();
  is = mf.getInsets();
  winx -= (is.left+is.right);
  winy -= (is.top+is.bottom);
  dim = new Dimension((winx*50)/100, winy-sbar.getHeight());
  spta.setPreferredSize(dim);
}}

//-------------------------------------
class CBSelection implements ListSelectionListener {
public void valueChanged(ListSelectionEvent e) {
int     idx;
  idx = lbox.getSelectedIndex();
  if (idx==-1) return;
  sidx = idx;
  PopItemMenu();
}}

//-------------------------------------
void CreateFileList() {
File           f;
int            i, nfil;
String         fc, fn, s;
  f = new File(ofd);
  files = f.listFiles();
  nfil = files.length;
  fils.clear();
  fc = "";
  for (i=0; i<nfil; i++) {
    f = files[i];
    fn = f.getName();
    if (fn.endsWith(".mp4")) {
    s = String.format("file '%s'\n", f.getPath());
    fc += s;
    }
  }
  fn = ofd + FILS;
  Util.SaveTextFile(new File(fn), fc, this);
}

//-------------------------------------
void CreateFileList(File[] sfa) {
File   f;
int    i, ne;
String fc, fn, s;
  ne = sfa.length;
  fc = "";
  for (i=0; i<ne; i++) {
    f = sfa[i];
    s = String.format("file '%s'\n", f.getPath());
    fc += s;
  }
  fn = ofd + FILS;
  Util.SaveTextFile(new File(fn), fc, this);
}

//-------------------------------------
public EdtVid(String[] args) {
Dimension dim;
Toolkit   tk;
  tk = Toolkit.getDefaultToolkit();
  dim = tk.getScreenSize();
  maxx = dim.width;
  maxy = dim.height;
}

//-------------------------------------
void GenerateImage(String vfn, String ifn) {
  cmd = String.format("ffmpeg -y -i %s -vf scale=128:128 -ss 0 -vframes 1 %s", vfn, ifn);
  RunCmd();
}

//-------------------------------------
void GenerateThumbs() {
File   f;
int    i, ne;
String ifn, vfn;
  ne = fils.size();
  for (i=0; i<ne; i++) {
    vfn = fils.get(i);
    ifn = NameNoExt(vfn);
    ifn += ".jpg";
    f = new File(ofd+ifn);
    if (!f.exists()) GenerateImage(vfn, ifn);
  }
}

//-------------------------------------
void Initlz() {
  InitlzVars();
  ReadIniFile();
  InitlzUI();
  LayoutUI();
}

//-------------------------------------
void InitlzUI() {
  winx = (wxp*maxx)/100;
  winy = (wyp*maxy)/100;
  uif = new Font(uifn, Font.BOLD, uifs);
  Util.PutUIManFonts(uif);
  taf = new Font(tafn, Font.PLAIN, tafs);
  sbar = new JButton(stxt);
  sbar.setFont(uif);
  sbar.addActionListener(new CBButton());
  sbar.addKeyListener(new CBKey());
  sbar.setBackground(new Color(0.5f, 0.1f, 0.1f));
  sbar.setForeground(new Color(1.0f, 1.0f, 0.1f));
  InitlzUIListBox();
  InitlzUITextArea();
  InitlzUIResources();
}

//-------------------------------------
void InitlzUIListBox() {
Dimension   dim;
JScrollBar  jsb;
  lbox = new JList<JLabel>();
  lbox.setCellRenderer(new LabelRender());
  lbox.setFont(taf);
  lbox.setBackground(new Color(0xFFFFFF));
  lbox.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  lbox.addListSelectionListener(new CBSelection());
  splb = new JScrollPane(lbox);
  splb.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
  splb.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
  jsb = splb.getVerticalScrollBar();
  dim = jsb.getPreferredSize();
  dim.width *=3;
  jsb.setPreferredSize(dim);
}

//-------------------------------------
void InitlzUIResources() {
Toolkit     tk;
URL         iurl;
  tk = Toolkit.getDefaultToolkit();
  iurl = mf.getClass().getResource("/EdtVid.png");
  iimg = tk.createImage(iurl);
  setIconImage(iimg);
}

//-------------------------------------
void InitlzUITextArea() {
Dimension   dim;
JScrollBar  jsb;
  txta = new JTextArea();
  txta.addKeyListener(new CBKey());
  txta.setFont(taf);
  txta.setBackground(new Color(0xFFFFFF));
  txta.setLineWrap(true);
  txta.setWrapStyleWord(true);
  txta.setTabSize(2);
  spta = new JScrollPane(txta);
  spta.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
  spta.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
  jsb = spta.getVerticalScrollBar();
  dim = jsb.getPreferredSize();
  dim.width *=2;
  jsb.setPreferredSize(dim);
}

//-------------------------------------
void InitlzVars() {
  uifn = Font.SERIF;
  uifs = UIFSIZ;
  tafn = Font.MONOSPACED;
  tafs = TAFSIZ;
  wxp = WXP;
  wyp = WYP;
  ofd = "";
  fils = new ArrayList<String>();
//  lm = new LogMsgs(APPNAM, mf);
  dbgn = -1;
  dend = -1;
  stxt = "Click Here";
}

//-------------------------------------
class ItemDelete implements ActionListener {
public void actionPerformed(ActionEvent qae) {
File   f;
String ifn;
  ifn = fils.get(sidx);
  ifn = ofd+ifn;
  f = new File(ifn);
  f.delete();
  ifn = NameNoExt(ifn);
  ifn += ".jpg";
  ifn = ofd+ifn;
  f = new File(ifn);
  f.delete();
  ListFiles();
}}

//-------------------------------------
class ItemDeleteBegin implements ActionListener {
public void actionPerformed(ActionEvent qae) {
File   f;
int    i, ne;
String ifn, msg;
  dbgn = sidx;
  if (dend==-1) return;
  msg = String.format("Delete from %d to %d", dbgn, dend);
  if (Util.DoIt(msg, mf)) {
    ne = fils.size();
    for (i=ne-1; i>=0; i--) {
      if ((i>=dbgn)&&(i<=dend)) {
        ifn = fils.get(i);
        ifn = ofd+ifn;
        f = new File(ifn);
        f.delete();
        ifn = NameNoExt(ifn);
        ifn += ".jpg";
        ifn = ofd+ifn;
        f = new File(ifn);
        f.delete();
      }
    }
    dbgn = -1;
    dend = -1;
  }
  ListFiles();
}}

//-------------------------------------
class ItemDeleteClear implements ActionListener {
public void actionPerformed(ActionEvent qae) {
  dbgn = -1;
  dend = -1;
}}

//-------------------------------------
class ItemDeleteEnd implements ActionListener {
public void actionPerformed(ActionEvent qae) {
File   f;
int    i, ne;
String ifn, msg;
  dend = sidx;
  if (dbgn==-1) return;
  msg = String.format("Delete from %d to %d", dbgn, dend);
  if (Util.DoIt(msg, mf)) {
    ne = fils.size();
    for (i=ne-1; i>=0; i--) {
      if ((i>=dbgn)&&(i<=dend)) {
        ifn = fils.get(i);
        ifn = ofd+ifn;
        f = new File(ifn);
        f.delete();
        ifn = NameNoExt(ifn);
        ifn += ".jpg";
        ifn = ofd+ifn;
        f = new File(ifn);
        f.delete();
      }
    }
    dbgn = -1;
    dend = -1;
  }
  ListFiles();
}}

//-------------------------------------
class ItemKeep implements ActionListener {
public void actionPerformed(ActionEvent qae) {
File   f;
int    i, ne;
String ifn, msg;
  ifn = fils.get(sidx);
  msg = String.format("Delete all but %s", ifn);
  if (Util.DoIt(msg, mf)) {
    ne = fils.size();
    for (i=0; i<ne; i++) {
      if (i!=sidx) {
        ifn = fils.get(i);
        ifn = ofd+ifn;
        f = new File(ifn);
        f.delete();
        ifn = NameNoExt(ifn);
        ifn += ".jpg";
        ifn = ofd+ifn;
        f = new File(ifn);
        f.delete();
      }
    }
    ifn = fils.get(sidx);
    ifn = NameNoExt(ifn);
    ifn += ".jpg";
    ifn = ofd+ifn;
    f = new File(ifn);
    f.delete();
  }
  ListFiles();
}}

//-------------------------------------
class ItemView implements ActionListener {
public void actionPerformed(ActionEvent qae) {
ArrayList<String> als;
String            ifn;
  ifn = fils.get(sidx);
  cmd = String.format("ffplay -fs -loop 0 %s", ifn);
  RunCmd();
  ListFiles();
}}

//-------------------------------------
public class LabelRender extends DefaultListCellRenderer {
public Component getListCellRendererComponent(JList jl, Object val, int idx, boolean sel, boolean focus) {
File   f;
JLabel lbl;
String ifn, vfn;
  lbl = (JLabel) super.getListCellRendererComponent(jl, val, idx, sel, focus);
  vfn = fils.get(idx);
  ifn = NameNoExt(vfn);
  ifn += ".jpg";
  f = new File(ofd+"/"+ifn);
  if (f.exists()) lbl.setIcon(new ImageIcon(ofd+"/"+ifn));
  else lbl.setIcon(new ImageIcon(iimg));
  lbl.setText(vfn);
  lbl.setHorizontalTextPosition(JLabel.RIGHT);
  return lbl;
}}

//-------------------------------------
void LayoutUI() {
  mf.addKeyListener(new CBKey());
  mf.addComponentListener(new CBResize());
  mf.setLocation((maxx-winx)/2, 0);
  mf.setSize(winx, winy);
  mf.getContentPane().add(sbar, BorderLayout.NORTH);
  mf.getContentPane().add(splb, BorderLayout.CENTER);
  mf.getContentPane().add(spta, BorderLayout.EAST);
  mf.setTitle("EdtVid");
  mf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  mf.setVisible(true);
}

//-------------------------------------
void ListFiles() {
File           f;
int            i, nfil;
String         fn;
  f = new File(ofd);
  files = f.listFiles();
  nfil = files.length;
  fils.clear();
  for (i=0; i<nfil; i++) {
    f = files[i];
    fn = f.getName();
    if (fn.endsWith(".mp4")) {
      fils.add(fn);
    }
  }
  nfil = fils.size();
  Util.SortSA(fils);
  GenerateThumbs();
  vjl = new Vector<JLabel>();
  for (i=0; i<nfil; i++) vjl.add(new JLabel(fils.get(i)));
  lbox.setListData(vjl);
}

//-------------------------------------
public static void main(String[] args) {
  mf = new EdtVid(args);
  mf.Initlz();
}

//-------------------------------------
String NameNoExt(String s) {
int    bidx, eidx;
String rv;
  eidx = s.lastIndexOf('.');
  bidx = s.lastIndexOf(File.separator);
  if (bidx<0) bidx = 0;
  rv = s.substring(bidx, eidx);
  return(rv);
}

//-------------------------------------
void PopItemMenu() {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("View");
  mi.setMnemonic('V');
  mi.addActionListener(new ItemView());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Delete");
  mi.setMnemonic('D');
  mi.addActionListener(new ItemDelete());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("DeleteBegin");
  mi.setMnemonic('B');
  mi.addActionListener(new ItemDeleteBegin());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("DeleteClear");
  mi.setMnemonic('C');
  mi.addActionListener(new ItemDeleteClear());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("DeleteEnd");
  mi.setMnemonic('E');
  mi.addActionListener(new ItemDeleteEnd());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Keep");
  mi.setMnemonic('K');
  mi.addActionListener(new ItemKeep());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}

//-------------------------------------
void PopupMain() {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("Video");
  mi.setMnemonic('V');
  mi.addActionListener(new AVideo());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Directory");
  mi.setMnemonic('D');
  mi.addActionListener(new ADirectory());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Minimize");
  mi.setMnemonic('M');
  mi.addActionListener(new AMinimize());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Quit");
  mi.setMnemonic('Q');
  mi.addActionListener(new AQuit());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}

//-------------------------------------
void ReadIniFile() {
BufferedReader  br;
Charset         cs;
File            inif;
Path            ifp;
String          jini, line, nam, val;
String[]        sa;
  jini = System.getenv("JINI")+"EdtVid.ini";
  inif = new File(jini);
  if (!inif.exists()) {
    stxt = "no ini file";
    return;
  }
  ifp = inif.toPath();
  cs = Charset.forName("US-ASCII");
  try {
    br = Files.newBufferedReader(ifp, cs);
    while ((line = br.readLine()) != null) {
      sa = line.split("=");
      if (sa.length==2) {
        nam = sa[0];
        val = sa[1];
        if (nam.compareTo(UIFNLIT)==0) uifn = val;
        if (nam.compareTo(UIFSLIT)==0) uifs = Integer.parseInt(val);
        if (nam.compareTo(TAFNLIT)==0) tafn = val;
        if (nam.compareTo(TAFSLIT)==0) tafs = Integer.parseInt(val);
        if (nam.compareTo(WXPLIT)==0) wxp = Integer.parseInt(val);
        if (nam.compareTo(WYPLIT)==0) wyp = Integer.parseInt(val);
      }
    }
  } catch (Exception x) { System.err.format("Exception: %s%n", x); }
}

//-------------------------------------
void RunCmd() {
BufferedReader br;
Process        p;
ProcessBuilder pb;
String         lin, plin;
StringBuilder  oput;
String[]       sa;
  sa = cmd.split(" ");
  try {
    pb = new ProcessBuilder(sa);
    pb.directory(new File(ofd));
    pb.redirectErrorStream(true);
    p = pb.start();
    plin = null;
    oput = new StringBuilder();
    br = new BufferedReader(new InputStreamReader(p.getInputStream()));
    while ((lin=br.readLine())!=null) {
      if (!lin.equals(plin)) {
        plin = lin;
        oput.append(lin).append('\n');
        txta.setText(oput.toString());
      }
    }
  } catch (Exception x) { System.err.format("Exception: %s%n", x); }
}

//-------------------------------------
void RunCmdString() {
BufferedReader br;
Process        p;
ProcessBuilder pb;
String         lin, plin;
StringBuilder  oput;
String[]       sa;
  cmd = Util.GetStringValue("verify command", cmd, mf);
  sa = cmd.split(" ");
  try {
    pb = new ProcessBuilder(sa);
    pb.directory(new File(ofd));
    pb.redirectErrorStream(true);
    p = pb.start();
    plin = null;
    oput = new StringBuilder();
    br = new BufferedReader(new InputStreamReader(p.getInputStream()));
    while ((lin=br.readLine())!=null) {
      if (!lin.equals(plin)) {
        plin = lin;
        oput.append(lin).append('\n');
        txta.setText(oput.toString());
      }
    }
  } catch (Exception x) { System.err.format("Exception: %s%n", x); }
}

//-------------------------------------
}
